--[[
                    __    ,- Made with ❤ by woOtzee.com
                   /✷_)      
           _.---._/ /
         /         /
      _/         |/
     /__.-|_|--|_| 
]]

local WOez_cframe = CreateFrame("Frame")
local WOez_MDOS = "Interface\\AddOns\\WO_ezcalinvit\\medias\\"
local WOez_Font = WOez_MDOS.."font_txt.ttf"
local WOez_open = false
local WOez_attend = {}
local WOez_2invit = {}
local WOez_2remov = {}
local WOez_2procs = 0
local WOez_progress = false
local WOez_LastUpdate = 0
local WOez_canEdit = false
local WOez_colorGrn = "00ffb7"
local WOez_colorRed = "ff4000"
local WOez_colorYel = "ffae00"
local WOez_DEBUG = false
local WOez_einfo = C_Calendar.GetEventInfo()
local WOez_isinGuild = IsInGuild()
local WOez_version = 0.5
-- -----------------------------------------------------------------------------

if  not IsAddOnLoaded("Blizzard_Calendar") then
    UIParentLoadAddOn("Blizzard_Calendar");
end

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
    
function WOF_Frame(name,type,where,opt,z,x,y,yy,zz,w,h)
    local obj = name
    local stuff = _G[obj] or CreateFrame(type,obj,where,opt)
    if z then stuff:SetPoint(z,x,y,yy,zz) end
    if w and h then stuff:SetSize(w,h) end
    return stuff
end
function WOF_FadeF(obj,where,allpoint,f)
    local obj = where:CreateTexture(nil, "BACKGROUND")             
    if allpoint then obj:SetAllPoints(true) end
    obj:SetColorTexture(0,0,0,f)
    return obj
end
function WOF_IconF(name,where,ico,z,x,y,w,h)
    local obj = name
    local stuff = _G[obj] or where:CreateTexture(obj,"HIGH") 
    stuff:SetPoint(z,x,y) stuff:SetSize(w,h) stuff:SetTexture(ico) 
    return stuff
end
function WOF_FontS(name,where,z,x,y,w,h,font,siz,justifyH)
    local obj = name
    local stuff = _G[obj] or where:CreateFontString(obj)   
    stuff:SetFont(font,siz) 
    stuff:SetPoint(z,x,y) 
    stuff:SetSize(w,h) 
    stuff:SetJustifyH(justifyH) 
    stuff:SetJustifyV("TOP") 
    return stuff
end

-- -----------------------------------------------------------------------------

function WOez_debugg(bug) if WOez_DEBUG then print(bug) end end
function WOez_count(tab)  local count = 0 for _ in pairs(tab) do count = count + 1 end return count end
function WOez_SendNotif(color,msg) DEFAULT_CHAT_FRAME:AddMessage("|cff"..color.."/!\\ INVIT:|r "..msg.."|r") end

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

WOez_cframe:RegisterEvent("PLAYER_LOGIN")
WOez_cframe:RegisterEvent("CALENDAR_OPEN_EVENT")
WOez_cframe:RegisterEvent("CALENDAR_UPDATE_ERROR")
WOez_cframe:RegisterEvent("CALENDAR_UPDATE_INVITE_LIST")
WOez_cframe:RegisterEvent("CALENDAR_UPDATE_EVENT")
WOez_cframe:RegisterEvent("CALENDAR_CLOSE_EVENT")
WOez_cframe:RegisterEvent("GUILD_ROSTER_UPDATE")
-- WOez_cframe:RegisterEvent("CALENDAR_ACTION_PENDING") 

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

WOez_cframe:SetScript("OnUpdate",function(self,elapsed)
    WOez_LastUpdate = WOez_LastUpdate + elapsed
    if WOez_LastUpdate > 2 then
        if WOez_open and WOez_2procs > 0 then
            WOez_debugg('WOez_2procs '..WOez_2procs)
            if not WOez_progress then
                if WOez_einfo then
                    local NumInv = C_Calendar.GetNumInvites()

                    WOez_2invitC= WOez_count(WOez_2invit)
                    WOez_2removC= WOez_count(WOez_2remov)
                    WOez_2procs = WOez_2invitC+WOez_2removC
                    if WOez_DEBUG then
                        local res = ""
                        res = ""  for k,v in pairs(WOez_2invit) do res = res..", "..k end WOez_debugg("--> "..WOez_2invitC.." WOez_2invit : "..res)
                        res = ""  for k,v in pairs(WOez_2remov) do res = res..", "..k end WOez_debugg("--> "..WOez_2removC.." WOez_2remov : "..res)
                        res = ""  for k,v in pairs(WOez_attend) do res = res..", "..k end WOez_debugg("--> WOez_attend : "..res)
                    end

                    if WOez_2invitC>0 then
                        if WOez_einfo.isLocked then 
                            WOez_SendNotif(WOez_colorRed,"|cff"..WOez_colorRed.."[ "..WOez_einfo.title.." ] locked...")
                            wipe(WOez_2invit)
                            WOez_roster() return
                        else
                            local toInvit, _ = next(WOez_2invit) 
                            WOez_msg_Handler("UPDATING: "..WOez_2procs.." Left...   |cffffbb00ADDING "..toInvit)
                            local AlreadyInv = false
                            if NumInv < 100 then
                                for i = 1, NumInv do
                                    local inviteData = C_Calendar.EventGetInvite(i)
                                    if toInvit == inviteData.name then 
                                        AlreadyInv = true 
                                        break
                                    end
                                end
                                if not AlreadyInv then 
                                    C_Calendar.EventInvite(toInvit) 
                                end
                            end
                            -- WOez_2invit[toInvit] = nil
                            WOez_roster_icon(WOez_einfo)
                            WOez_2invitC = WOez_2invitC-1
                        end
                    elseif WOez_2removC>0 then
                        local toInvit, _ = next(WOez_2remov) 
                        
                        WOez_msg_Handler("UPDATING: "..WOez_2procs.." Left...   |cffffbb00REMOVING "..toInvit)
                        for i = 1, NumInv do
                            local inviteData = C_Calendar.EventGetInvite(i)
                            if toInvit == inviteData.name then 
                               C_Calendar.EventRemoveInvite(i) 
                               break
                            end
                        end
                        -- WOez_2remov[toInvit] = nil
                        WOez_roster_icon(WOez_einfo)
                        WOez_2removC = WOez_2removC-1
                    end
                    
                    WOez_2procsN= WOez_count(WOez_2invit)+WOez_count(WOez_2remov)
                    if WOez_2procsN == 0 then WOez_roster_icon(WOez_einfo) end
                else
                    WOez_2reset_Handler()
                end
            end
        else
            WOez_2reset_Handler()
        end        
        WOez_LastUpdate = 0;
    end
end)

WOez_cframe:SetScript("OnEvent",function(self,event,...)
    WOez_debugg(event)
    
    -- -------------------------------------------------------------------------
    if event == "PLAYER_LOGIN" then
        local arg = ... 
        WOez_debugg('----- WOez_isinGuild : '..tostring(WOez_isinGuild))
        if not WO_ez_DB or WO_ez_DB.version ~= WOez_version then
            local welcom = "\n\n|cffffbb00 * * * * * * * *|r\n\nWelcome back guys !\nNew Stuff on WOEZ Calendar "..WOez_version.."\n"
            welcom = welcom.."\n- Many bugs fixed and performances improved"
            welcom = welcom.."\n- You can now hide some guild rank (check in options /woez)"
            welcom = welcom.."\n- Choose on which rank is GuildMaster"
            welcom = welcom.."\n\n|cffffbb00 * * * * * * * *|r\n"
            print(welcom)
        end
        if not WO_ez_DB then    
            WOez_debugg('----- Initialize WO_ez_DB')
            WO_ez_DB = { }
            WO_ez_DB.version = WOez_version
        end    
        if not WO_ez_DBC then   
            WOez_debugg('----- Initialize WO_ez_DBC')
            WO_ez_DBC = { }
        end
        WO_ez_DB.version = WOez_version

    -- -------------------------------------------------------------------------
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_OPEN_EVENT" then
        local eventType = ... WOez_2reset_Handler()
        if eventType == "PLAYER" or eventType == "GUILD_EVENT" then 
            WOez_open = true    WOez_roster() 
        else 
            WOez_open = false   WOez_roster()
        end
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_ERROR" then  
        WOez_progress = false 
        WOez_roster() 
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_INVITE_LIST" then
        if WOez_progress then
            WOez_progress = false 
            WOez_open = true        
        else
            WOez_einfo = C_Calendar.GetEventInfo()
            WOez_roster_icon(WOez_einfo) 
        end
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_CLOSE_EVENT" then
        WOez_open = false       WOez_roster() 
    -- -------------------------------------------------------------------------
    elseif event == "GUILD_ROSTER_UPDATE" then
        local arg = ...      
        if arg == true then     WOez_roster() end
    -- -------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_EVENT" then
        WOez_roster()
    -- ------------------------------------------------------------------------- 
    elseif event == "CALENDAR_ACTION_PENDING" then 
        local arg = ...  
        if arg == false and WOez_open then WOez_roster_icon(WOez_einfo)  end 
    -- -------------------------------------------------------------------------
    end
    return 
end)

function WOez_2Handler(who,add) 
    if add then 
        WOez_debugg("|cff85e2ff    CALL WOez_2Handler ADD "..who)
        WOez_2invit[who]=true      
        WOez_2remov[who]=nil 
    else 
        WOez_debugg("|cff85e2ff    CALL WOez_2Handler RMV "..who)
        WOez_2remov[who]=true 
        WOez_2invit[who]=nil 
    end
    WOez_2procs = WOez_2procs+1
    WOez_InProgress:Show() Fade4:Show() 
end
function WOez_msg_Handler(msg) WOez_InProgress:SetText(msg) WOez_InProgress:Show() Fade4:Show() end
function WOez_2reset_Handler() WOez_2procs=0 wipe(WOez_2invit) wipe(WOez_2remov) WOez_InProgress:SetText("UPDATING...") WOez_InProgress:Hide() Fade4:Hide() end
-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

function WOez_GetEventInfo() 
    WOez_debugg("|cffee00ff    CALL WOez_GetEventInfo + WOez_attend")
    wipe(WOez_attend)
    local Invites, Comming, NoReply, NotCmmg, WatCmmg, nbTNK, nbHLS, nbMLE, nbRNG = 0,0,0,0,0,0,0,0,0
    local NumInv = C_Calendar.GetNumInvites()
    for i = 1, NumInv do
        local inviteData = C_Calendar.EventGetInvite(i)
        if inviteData.name ~= nil then 
            WOez_attend[inviteData.name] = {index=i,inviteStatus=inviteData.inviteStatus} 
            Invites = Invites+1
                if inviteData.inviteStatus==1 then NoReply=NoReply+1 -- CALENDAR_INVITESTATUS_INVITED
            elseif inviteData.inviteStatus==2 then Comming=Comming+1 -- CALENDAR_INVITESTATUS_ACCEPTED
            elseif inviteData.inviteStatus==3 then NotCmmg=NotCmmg+1 -- CALENDAR_INVITESTATUS_DECLINED
            elseif inviteData.inviteStatus==4 then Comming=Comming+1 -- CALENDAR_INVITESTATUS_CONFIRMED
            elseif inviteData.inviteStatus==5 then NotCmmg=NotCmmg+1 -- CALENDAR_INVITESTATUS_OUT
            elseif inviteData.inviteStatus==6 then WatCmmg=WatCmmg+1 -- CALENDAR_INVITESTATUS_STANDBY
            elseif inviteData.inviteStatus==7 then Comming=Comming+1 -- CALENDAR_INVITESTATUS_SIGNEDUP
            elseif inviteData.inviteStatus==8 then NoReply=NoReply+1 -- CALENDAR_INVITESTATUS_NOT_SIGNEDUP
            elseif inviteData.inviteStatus==9 then WatCmmg=WatCmmg+1 -- CALENDAR_INVITESTATUS_TENTATIVE
            end
            WOez_2invit[inviteData.name] = nil
        end
    end
    for k,_ in pairs(WOez_2remov) do 
        if not WOez_attend[k] then WOez_2remov[k]=nil end
    end 
    nbInvit:SetText(format('|cffffffff %s INVITS :',Invites) )
    nbCommg:SetText(format('|cffffbb00 %s',Comming) )
    nbNRply:SetText(format('|cffb8b8b8 %s ( +%s )',NoReply,WatCmmg)  )
    nbNCmmg:SetText(format('|cffe60000 %s',NotCmmg) )
end

-- -----------------------------------------------------------------------------

function WOez_GetIcon(ico) 
    local icon = '.tga'
        if ico==0 then icon =   "onway"..icon  elseif ico==1 then icon = "nbNRply"..icon
    elseif ico==2 then icon = "nbCommg"..icon  elseif ico==3 then icon = "nbNCmmg"..icon
    elseif ico==4 then icon = "nbCommg"..icon  elseif ico==5 then icon = "nbNCmmg"..icon
    elseif ico==6 then icon = "nbNRply"..icon  elseif ico==7 then icon = "nbCommg"..icon
    elseif ico==8 then icon = "nbNRply"..icon  elseif ico==9 then icon = "nbNRply"..icon end    
    return WOez_MDOS..icon
end

function WOez_roster_icon(WOez_einfo)
    WOez_debugg('|cffff3000---------------------- -> try refresh icones... ? |r')
    if WOez_open and WOez_einfo then
        WOez_debugg('|cffff3000---------------------- -> Refresh Roster icones |r')

        WOez_GetEventInfo()
        local allWOez_child = { WOez_child:GetChildren() };
        for _, WOez_children in ipairs(allWOez_child) do 
            if WOez_children:GetObjectType() == "CheckButton" then 
                local name_icone = WOez_children:GetName()
                local icone = _G[name_icone.."_ico"]
                local fname = _G[name_icone.."a"]
                if fname then
                    local nname = fname:GetText()
                    local atten = WOez_attend[nname]
                    local isinv = WOez_2invit[nname] 
                    local isrmv = WOez_2remov[nname] 

                        if isinv then WOez_children:SetChecked(true) 
                    elseif isrmv then WOez_children:SetChecked(false) 
                    elseif atten then WOez_children:SetChecked(true) 
                                 else WOez_children:SetChecked(false) end
                             
                    if WOez_canEdit and not WOez_einfo.isLocked and WOez_einfo.calendarType == "PLAYER" and nname ~= UnitName("player") then
                        WOez_children:SetEnabled(true) 
                    else 
                        WOez_children:SetEnabled(false) 
                    end
                    if icone then
                        if isinv or isrmv then
                            icone:SetTexture(WOez_GetIcon(0))
                        elseif atten then
                            icone:SetTexture(WOez_GetIcon(atten.inviteStatus)) 
                        else
                            icone:SetTexture(nil) 
                        end
                    end
                end
            end
        end
    end
end            

-- -----------------------------------------------------------------------------

function WOez_roster()
    WOez_einfo = C_Calendar.GetEventInfo()
    GuildRoster()  WOez_isinGuild = IsInGuild()
    WOez_debugg('----- WOez_isinGuild : '..tostring(WOez_isinGuild))
    WOez_debugg('|cffff6000---------------------- -> Refresh ??|r')
    if WOez_einfo and WOez_open and _G.CalendarFrame and _G.CalendarFrame:IsShown() and (WOez_einfo.calendarType == "PLAYER" or WOez_einfo.calendarType == "GUILD_EVENT") then
        WOez_debugg('|cffff6000---------------------- -> Refresh Roster|r')
        if C_Calendar.EventCanEdit() then WOez_canEdit = true else WOez_canEdit = false end

        WOez_GetEventInfo()
        local margin=3 if ElvUI then margin=0 end
        if WOez_canEdit then 
            WOez_cframe:SetPoint(   "TOPLEFT",_G.CalendarCreateEventFrame,   "TOPRIGHT",22, 0-margin)
            WOez_cframe:SetPoint("BOTTOMLEFT",_G.CalendarCreateEventFrame,"BOTTOMRIGHT",22, 0+margin)
        else
            WOez_cframe:SetPoint(   "TOPLEFT",_G.CalendarViewEventFrame,   "TOPRIGHT",22, 0-margin)
            WOez_cframe:SetPoint("BOTTOMLEFT",_G.CalendarViewEventFrame,"BOTTOMRIGHT",22, 0+margin)
        end

        local allWOez_child = { WOez_child:GetChildren() };
        for _, WOez_children in ipairs(allWOez_child) do WOez_children:Hide() end

        local RosterGuild = {}
        local hei = 0
        
        if WOez_isinGuild then
            local numGuildMembers, numOnline, numOnlineAndMobile = GetNumGuildMembers()
            for z=1,numGuildMembers do
                local name, _, rankIndex, level, _, _, note, _, _, _, classFileName,  _, _, _ = GetGuildRosterInfo(z);
                local rang = rankIndex+1 if rankIndex == 0 then rang = WO_ez_DBC.guildrankGM or 2 end
                if RosterGuild[rang] == nil then RosterGuild[rang] = {} end 
                RosterGuild[rang][z] = {Nname=Ambiguate(name,"guild"),lvl=level,note=note,classcolor=RAID_CLASS_COLORS[classFileName]}
            end

            for i=2, GuildControlGetNumRanks() do
                local Nname = GuildControlGetRankName(i)
                local IsRankHide = WO_ez_DBC.guildranks or {}
                if RosterGuild[i] ~= nil and Nname ~= nil and not IsRankHide[i] then 

                    local titl = WOF_Frame("WOez_childt_"..i,"Frame",WOez_child,nil,"TOPLEFT",6,"-"..hei+5,nil,nil,80,16) titl:Show()
                    local tixt = WOF_FontS("WOez_childx_"..i,titl,"TOPLEFT",0,-2,116,16,WOez_Font,9,"LEFT")  
                    tixt:SetText(string.upper(Nname).." ........................................................................") tixt:SetTextColor(1,1,1,1) 

                    hei = hei+20
                    for k,c in pairs(RosterGuild[i]) do
                        local color = c.classcolor  
                        if c.lvl < UnitLevel("player") then alpha = .3 else alpha = 1 end

                        local bttn = WOF_Frame("WOez_childs_"..k,"CheckButton",WOez_child,"ChatConfigCheckButtonTemplate","TOPLEFT",5,"-"..hei-1,nil,nil,9,9.5)
                        local icon = WOF_IconF("WOez_childs_"..k.."_ico",bttn,nil,"TOPLEFT", 49,-1,7,7) 
                        local attn = WOez_attend[c.Nname]
                        if attn then 
                            bttn:SetChecked(true) 
                            icon:SetTexture(WOez_GetIcon(attn.inviteStatus)) 
                        else 
                            bttn:SetChecked(false)  
                            icon:SetTexture(nil) 
                        end
                        -- 
                        bttn:SetScript("OnClick", function(self, button)
                            isChecked = self:GetChecked()
                            if isChecked then 
                                -- color = c.classcolor  escapeColor = string.format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
                                -- WOez_SendNotif(WOez_colorGrn,"[ "..WOez_einfo.title.." ] +"..escapeColor..c.Nname)
                                icon:SetTexture(WOez_GetIcon(0))  WOez_2Handler(c.Nname,true)
                            else 
                                -- color = c.classcolor  escapeColor = string.format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
                                -- WOez_SendNotif(WOez_colorRed,"[ "..WOez_einfo.title.." ] -"..escapeColor..c.Nname)
                                icon:SetTexture(WOez_GetIcon(0))  WOez_2Handler(c.Nname,false)
                            end
                        end)    
                        if WOez_canEdit and not WOez_einfo.isLocked and WOez_einfo.calendarType == "PLAYER" and c.Nname ~= UnitName("player") then
                            bttn:SetEnabled(true) 
                        else
                            bttn:SetEnabled(false)
                        end

                        local text = WOF_FontS("WOez_childs_"..k.."a",bttn,"TOPLEFT",10,-1,40,8,WOez_Font,7,"LEFT")  text:SetText(c.Nname) text:SetTextColor(color.r, color.g, color.b,alpha) 
                        local ilvl = WOF_FontS("WOez_childs_"..k.."b",bttn,"TOPLEFT",47,-1,20,8,WOez_Font,7,"RIGHT") ilvl:SetText(c.lvl)   ilvl:SetTextColor(1,1,1,alpha)  
                        local note = WOF_FontS("WOez_childs_"..k.."c",bttn,"TOPLEFT",70,-1,48,8,WOez_Font,7,"LEFT")  note:SetText(c.note)  note:SetTextColor(.4,.4,.4,alpha)       

                        bttn:Show()
                        hei = hei+8
                    end 
                end 
            end
        else
            
            local titl = WOF_Frame("WOez_childt_0","Frame",WOez_child,nil,"TOPLEFT",6,"-"..hei+5,nil,nil,80,16) titl:Show()
            local tixt = WOF_FontS("WOez_childx_0",titl,"TOPLEFT",0,-2,116,16,WOez_Font,9,"LEFT")  
            tixt:SetText(" NO GUILDIES ??!   :(") tixt:SetTextColor(1,1,1,1) 
        end
        if hei < 100 then hei = 101 end
        WOez_child:SetSize(130, hei+4) 
        WOez_ScrollBar:SetMinMaxValues(1, hei-100)
        WOez_cframe:Show() 
    else
        WOez_2reset_Handler()
        WOez_cframe:Hide()
    end
end

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

    WOez_cframe = WOF_Frame("WOez_cframe","Frame",nil,nil,nil,nil,nil,nil,nil,136,100) WOez_cframe:SetFrameStrata("MEDIUM")     
    if not ElvUI then WOez_cframe:SetBackdrop({ edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 8 }) end
    local WOez_InProgress = WOF_FontS("WOez_InProgress",WOez_cframe,"BOTTOMLEFT",10,-37,136,30,WOez_Font,7,"LEFT") WOez_InProgress:SetText("UPDATING...")  WOez_InProgress:Hide()

-- -----------------------------------------------------------------------------

    WOez_Infos = WOF_Frame("WOez_Infos","Frame",WOez_cframe,nil,"TOPLEFT",WOez_cframe,"TOPLEFT",4,-4,128,32)

    nbInvit = WOF_FontS("WOez_nbInvit",WOez_Infos,"TOPLEFT",  6,-4,70,8,WOez_Font,7,"LEFT") nbInvit:SetText('|cffffffff?? INVITS :') 
    nbCommg = WOF_FontS("WOez_nbCommg",WOez_Infos,"TOPLEFT", 52,-4,30,8,WOez_Font,7,"LEFT") nbCommg:SetText('|cffffbb00??') 
    nbNRply = WOF_FontS("WOez_nbNRply",WOez_Infos,"TOPLEFT", 73,-4,50,8,WOez_Font,7,"LEFT") nbNRply:SetText('|cffb8b8b8??') 
    nbNCmmg = WOF_FontS("WOez_nbNCmmg",WOez_Infos,"TOPLEFT",115,-4,30,8,WOez_Font,7,"LEFT") nbNCmmg:SetText('|cffe60000??') 
      
    icCommg = WOF_IconF("WOez_icCommg",WOez_Infos,WOez_MDOS.."nbCommg.tga","TOPLEFT", 42,-3.25,8,8) 
    icNRply = WOF_IconF("WOez_icNRply",WOez_Infos,WOez_MDOS.."nbNRply.tga","TOPLEFT", 65,-3   ,9,9) 
    icNCmmg = WOF_IconF("WOez_icNCmmg",WOez_Infos,WOez_MDOS.."nbNCmmg.tga","TOPLEFT",105,-3   ,9,9) 

-- -----------------------------------------------------------------------------

    WOez_ScrollFrame = WOF_Frame("WOez_SF","ScrollFrame",WOez_cframe,nil,"TOPLEFT", WOez_cframe, "TOPLEFT",4,-24,nil,nil)
    WOez_ScrollFrame:SetPoint("BOTTOMRIGHT", WOez_cframe, "BOTTOMRIGHT",-4,4)
    WOez_cframe.ScrollFrame = WOez_ScrollFrame

    WOez_ScrollBar = WOF_Frame("WOez_SB","Slider",WOez_cframe.ScrollFrame,"UIPanelScrollBarTemplate","TOPLEFT", WOez_cframe,"TOPRIGHT",2,-10,nil,nil)
    WOez_ScrollBar:SetPoint("BOTTOMLEFT", WOez_cframe, "BOTTOMRIGHT", 4, 10)
    WOez_ScrollBar:SetMinMaxValues(1, 200) WOez_ScrollBar:SetValueStep(10) WOez_ScrollBar.scrollStep = 10 WOez_ScrollBar:SetValue(0) 
    WOez_ScrollBar:SetScript("OnValueChanged",function (self, value) self:GetParent():SetVerticalScroll(value) end)

    WOez_child = WOF_Frame("WOez_Chil","Frame",WOez_ScrollFrame,nil,nil,nil,nil,0,0,nil,nil)
    WOez_cframe.ScrollFrame:SetScrollChild(WOez_child)
    WOez_cframe.ScrollFrame:SetScript("OnMouseWheel", function (self, value) value = value*-1 val = WOez_ScrollBar:GetValue()+value*10 WOez_ScrollBar:SetValue(val) end)
    WOez_ScrollBar:SetScript(         "OnMouseWheel", function (self, value) value = value*-1 val = WOez_ScrollBar:GetValue()+value*10 WOez_ScrollBar:SetValue(val) end)

-- -----------------------------------------------------------------------------

    Fade1 = WOF_FadeF(WOez_cframe.textur1,WOez_cframe,true,.4)
    Fade2 = WOF_FadeF(WOez_cframe.textur2,WOez_cframe.ScrollFrame,true,.6)    
    Fade3 = WOF_FadeF(WOez_cframe.textur3,WOez_Infos ,false,.6)  Fade3:SetSize(128,16)  Fade3:SetPoint("TOPLEFT",0,0 ) 
    Fade4 = WOF_FadeF(WOez_cframe.textur4,WOez_cframe,false,.8)  Fade4:SetSize(136,16)  Fade4:SetPoint("BOTTOMLEFT",0,-18 ) Fade4:Hide()

-- -----------------------------------------------------------------------------

    WOez_SB:SetWidth(10)      WOez_SBThumbTexture:SetWidth(10)     WOez_SBThumbTexture:SetHeight(10)
                          WOez_SBScrollDownButton:SetWidth(10) WOez_SBScrollDownButton:SetHeight(10)
                            WOez_SBScrollUpButton:SetWidth(10)   WOez_SBScrollUpButton:SetHeight(10)

-- -----------------------------------------------------------------------------

    WOez_cframe:Hide()
    
-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

    local Options = CreateFrame("Frame", "WOEZOptions", InterfaceOptionsFramePanelContainer)
    Options.name = "WOEZ Calendar Invit" InterfaceOptions_AddCategory(Options)

    Options:Hide()
    Options:SetScript("OnShow", function(self)
    	local Title = self:CreateFontString("$parentTitle", "ARTWORK", "GameFontNormalLarge")
    	Title:SetPoint("TOPLEFT", 16, -16)
    	Title:SetText(self.name)

        local SubText = self:CreateFontString("$parentSubText", "ARTWORK", "GameFontHighlightSmall")
        SubText:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -8)
        SubText:SetPoint("RIGHT", -32, 0)   SubText:SetHeight(32) 
        SubText:SetJustifyH("LEFT")         SubText:SetJustifyV("TOP")
        SubText:SetText("v"..WO_ez_DB.version)

        local NoGuild = self:CreateFontString("$parentNoGuild", "ARTWORK", "GameFontNormalLarge")
        NoGuild:SetPoint("CENTER", SubText, 0, -108)
        NoGuild:SetJustifyH("CENTER")       NoGuild:SetText("No Guild no options...")
        NoGuild:Hide()

        function self:refresh()
            WOez_roster()
            local infos = {}
            for i=0, 20 do
                local obj = "ShowRank"..i
                if _G[obj] then _G[obj]:Hide() end
            end
            guildName = GetGuildInfo("player")
            if guildName~= nil then
                NoGuild:Hide()
                WO_ez_DBC.guildranks = WO_ez_DBC.guildranks or {}
                local HShowRank = -4
                for i=2, GuildControlGetNumRanks() do
                    local Nname = GuildControlGetRankName(i)
                    local obj = "ShowRank"..i
                    local ShowRank = _G[obj] or CreateFrame("CheckButton",obj, WOEZOptions, "InterfaceOptionsCheckButtonTemplate")
                    ShowRank:SetPoint("TOPLEFT", SubText, "BOTTOMLEFT", 0, HShowRank)
                    ShowRank.Text:SetText("Show rank "..Nname)
                    ShowRank:SetScript("OnClick", function(this)
                        local checked = not not this:GetChecked()
                        if checked then WO_ez_DBC.guildranks[i] = nil else WO_ez_DBC.guildranks[i] = true end
                        self:refresh()
                    end)
                    ShowRank:Show()
                    if not WO_ez_DBC.guildranks[i] then ShowRank:SetChecked(true) else ShowRank:SetChecked(false) end
                    HShowRank = HShowRank -30
                    infos[i] = Nname
                end

                HShowRank = HShowRank -30
                WO_ez_DBC.guildrankGM = WO_ez_DBC.guildrankGM or 2
                local info = {}
                local obj = "ShowRank1"
                local GMRankDropdown = _G[obj] or CreateFrame("Frame",obj, WOEZOptions, "UIDropDownMenuTemplate")
                GMRankDropdown:SetPoint("TOPLEFT", SubText, "BOTTOMLEFT", -15, HShowRank)
                UIDropDownMenu_SetWidth(GMRankDropdown, 400)
                GMRankDropdown.initialize = function()
                    wipe(info)
                    for u, grank in pairs(infos) do
                         info.text = 'Show GuildMaster in '..grank
                         info.value = u
                         info.func = function(self)
                            WO_ez_DBC.guildrankGM = self.value
                            info.checked = self.value == self.text 
                            ShowRank1Text:SetText(self:GetText())
                            WOez_roster()
                        end
                        info.checked = u == WO_ez_DBC.guildrankGM
                        UIDropDownMenu_AddButton(info)
                    end
                end
               if infos[WO_ez_DBC.guildrankGM] then ShowRank1Text:SetText('Show GuildMaster in '..infos[WO_ez_DBC.guildrankGM]) end
                GMRankDropdown:Show()
            else
                NoGuild:Show()
            end 

        end
        self:refresh()
        self:SetScript("OnShow", nil)
    end)

---- -----------------------------------------------------------------------------

SLASH_WOEZ1 = "/woez"
SlashCmdList.WOEZ = function()
	InterfaceOptionsFrame_OpenToCategory(Options)
    InterfaceOptionsFrame_OpenToCategory(Options)
end